﻿Public Class ChangableLabel
    '============================================================================
    'ChangableLabel class created by Brandon Milton (brandonio21)
    'This class was created specifically for a tutorial on the BrandonioProductions YouTube channel
    '     You can find this channel at: http://youtube.com/BrandonioProductions
    'Discussion of this class is held at BP Forums
    '     A direct link to the thread: http://bpforums.info/viewtopic.php?f=22&t=745&sid=56a2aef755364e2141a09ddcd86af998
    'Feel free to use this class in any way, but please remember to credit the author somewhere in the application
    '=============================================================================

    Public Property IdentifierText As String
        'This property allows us to change the text of the first label when objectilized (sp?)
        Get
            Return lbl_identifier.Text
        End Get
        Set(value As String)
            lbl_identifier.Text = value
        End Set
    End Property
    Public Property InformationText As String
        'This property allows us to change the text of the second label when objectilized (sp?)
        Get
            Return lbl_information.Text
        End Get
        Set(value As String)
            lbl_information.Text = value
        End Set
    End Property

    Private Sub lbl_information_MouseDoubleClick(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles lbl_information.MouseDoubleClick
        'Here we want the textbox to appear
        Dim oldLabel As Label = CType(flp_main.Controls.Item(1), Label) 'Save the label
        flp_main.Controls.RemoveAt(1) 'Remove the label from the FlowLayoutPanel (so it can be replaced)

        Dim txt_information As New TextBox 'Create textbox
        Dim textboxSize As New Size(GetLabelWidth(oldLabel) + 25, txt_information.Size.Height) 'set size to ~ same size as label to avoid awkwardness
        txt_information.Size = textboxSize 'set the size
        txt_information.Text = oldLabel.Text 'set the text as old label text
        AddHandler txt_information.KeyPress, AddressOf txt_information_keypress 'add handler to detect "enter" presses

        flp_main.Controls.Add(txt_information) 'add the textbox to the FlowLayoutPanel
    End Sub

    Private Function GetLabelWidth(ByVal label As Label) As Integer
        'This method gets the pixel width of labels
        Dim g As Graphics = label.CreateGraphics() 'create graphix object for label to access info
        Dim fontSize As SizeF 'var to save font sizes
        fontSize = g.MeasureString(label.Text, label.Font) 'save the pixeled size of the label's text
        Return fontSize.Width 'return the object (this is a function, afterall)
    End Function
    Private Sub txt_information_keypress(sender As Object, e As KeyPressEventArgs)
        'this method is used to detect when the enter key is pressed on the textbox, return everything to normal state
        If (e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Enter)) Then
            Dim txt_information As TextBox = CType(sender, TextBox) 'save textbox var
            Dim newLabel As New Label 'create new label
            newLabel.AutoSize = True 'This gave lots of problems; allows for the control to resize with new label
            newLabel.Text = txt_information.Text 'set the labels text to user input
            AddHandler newLabel.MouseDoubleClick, AddressOf lbl_information_MouseDoubleClick
            AddHandler newLabel.TextChanged, AddressOf ResizeControl
            '^Adding handlers to resize the control and to detect double clicks, self-explanatory

            'now we need to remove the textbox and add the label
            flp_main.Controls.RemoveAt(1)
            flp_main.Controls.Add(newLabel)


            ResizeControl() 'resize the entire control to fit the new objects
        End If
    End Sub

    Private Sub ResizeControl() Handles lbl_identifier.TextChanged, lbl_information.TextChanged
        'this method resizes the control to fit the new objects and to make room for others around it

        'create vars to hold size information
        Dim identLabel As Label = CType(flp_main.Controls.Item(0), Label) 'save copy of first label
        Dim infoLabel As Label = CType(flp_main.Controls.Item(1), Label) 'save copy of second label
        Dim paddingSpace As Integer = 50

        Dim width As Integer = GetLabelWidth(identLabel) + GetLabelWidth(infoLabel) + paddingSpace 'add all the widths!
        Me.Size = New Size(width, Me.Size.Height) 'set the new size
    End Sub

End Class
